let providers = new Map()
providers.set("www.youtube.com", "youtube")
providers.set("youtube.com", "youtube")
providers.set("youtu.be", "youtube")
providers.set("tv.nrk.no", "nrk")
providers.set("seafile.purser.it", "seafile")

const random = () => {
    const arr = new Uint8Array(32)
    window.crypto.getRandomValues(arr)
    return [...arr].map(x => x.toString(16).padStart(2, "0")).join("")
}

document.addEventListener("DOMContentLoaded", () => {
    let [proxyButton, kodiButton] = document.getElementsByTagName("button")
    proxyButton.addEventListener("click", (ev) => {
        chrome.tabs.query({currentWindow: true, active: true}, (tabs) => {
            let oldurl = new URL(tabs[0].url)
            let newurl = new URL("https://stream.purser.it")
            let search = new URLSearchParams()
            let hostname = oldurl.hostname.toLowerCase()
            if(providers.has(hostname)) {
                if(hostname.includes("youtube.com")) {
                    let newpath = oldurl.searchParams.get("v")
                    if((newpath instanceof String) || ((typeof newpath) === "string")) {
                        newurl.pathname = "/" + newpath
                    }
                } else {
                    newurl.pathname = oldurl.pathname
                }
                search.append("provider", providers.get(hostname))
            }
            newurl.search = search.toString()
            let tab = {}
            tab.url = newurl.href
            chrome.tabs.create(tab)
        })
    })
    kodiButton.addEventListener("click", (ev) => {
        chrome.tabs.query({currentWindow: true, active: true}, (tabs) => {
            let oldurl = new URL(tabs[0].url)
            let newurl = new URL("https://stream.purser.it")
            let search = new URLSearchParams()
            let hostname = oldurl.hostname.toLowerCase()
            if(providers.has(hostname)) {
                if(hostname.includes("youtube.com")) {
                    newurl = new URL("plugin://plugin.video.youtube")
                    search.append("action", "play_video")
                    let video_id = oldurl.searchParams.get("v")
                    if(video_id) {
                        search.append("videoid", video_id)
                    }
                } else {
                    search.append("provider", providers.get(hostname))
                    search.append("raw", "true")
                    newurl.pathname = oldurl.pathname
                }
            }

            newurl.search = search.toString()

            let req = {
                jsonrpc: "2.0",
                method: "Player.Open",
                id:     random(),
                params: {
                    item: {
                        file: newurl.href
                    }
                }
            }

            try {
                fetch("http://127.0.0.1:4000/jsonrpc", {
                    method: "POST",
                    body: JSON.stringify(req),
                    headers: {
                        "Content-Type": "application/json; charset=utf-8"
                    }
                }).then(resp => console.log(resp))
            } catch(e) {
                console.log(e)
            }
        })
    })
})
